#The provided R function, nchoosek, is a custom implementation designed 
#to generate all combinations of a given length col from a sequence seq. 
#It's intended to mimic some functionality of the combination operation "n choose k" 
#which selects k unique items from a set of n items. 

nchoosek = function(seq, col){#'seq' is the input vector from which combinations are done, 'col' is the number of elements
  res = expand.grid(seq, seq, seq)#generates all possible combinations of the elements in seq with itself repeated 3 times (full cartesian product)
  res = data.frame(res[, 1:col])#if 'col' is less than 3, the function will still work
  res <- data.frame(res[!duplicated(res),])#removing duplicate
  if (col > 1){
    mask <- matrix(t(apply(res, 1, function(x){diff(x)})), ncol = col-1)
    mask2 = apply(mask, 1, function(x){all(x>0)})
    res <- res[mask2,]
    rownames(res) <- NULL
  }
#ensures increasing order (if 'col'>1)
  return(unname(res))
}
#limitations: only up to 3 elements, suitable for small sized sequence because it is computationaly expensive400 * (U_OTHER - kronecker(t(U_HA), matrix(1, ncol(FC_OTHER), 1)));
delta_OTHER_CT = 400 * (U_OTHER_CT - kronecker(t(U_HA), matrix(1, ncol(FC_OTHER_CT) ,1)));
#Calculate the utility difference (delta) between each econometric model and the historical average, by 400 to annualize the result
#kronecker expands the historical average across all econometric models
#the subtraction determines the performance improvement or degradation of each model against historical average

# %save('Forecasts_quarterly_store','actual','FC_HA','FC_ECON','beta_ECON',...
#       %    'FC_ECON_CT','FC_OTHER','FC_OTHER_CT','FC_VOL','w_HA','w_ECON',...
#       %    'w_ECON_CT','w_OTHER','w_OTHER_CT','delta_ECON','delta_ECON_CT',...
#       %    'delta_OTHER_CT');


 # Writing results to spreadsheet #

Unrestricted <- data.frame(cbind(c(delta_ECON[, 1], delta_OTHER[, 1]) ,c( delta_ECON[, 2], delta_OTHER[, 2]), c(delta_ECON[, 3], delta_OTHER[, 3])))
colnam