#The Perform_asset_allocation function is designed to simulate an asset allocation strategy 
#using principles from portfolio theory. It calculates the optimal weights for a risky asset 
#based on forecasts of returns, the associated risk (volatility), and a risk-aversion parameter. 
#The function then computes the expected utility from implementing this allocation over a specified period.

Perform_asset_allocation = function(actual,risk_free,forecast,volatility_forecast,gamma_MV){
  
  T = length(actual);
  weight_risky = matrix(0, nrow = T, ncol = 1)
  for (iter in 1:T){
    weight_risky[iter] = (1/gamma_MV) * (forecast[iter] / volatility_forecast[iter])
#calculates the weight of the risky asset based on the forecasted return-to-volatily ratio
#adjusted by the investor's risk aversion (Gamma_MV)
    if (weight_risky[iter] < 0){
      weight_risky[iter] = 0
    }else if (weight_risky[iter]>1.5){
      weight_risky[iter]=1.5
#weights are constrained to be non-negative (no short selling) and capped at 1.5 (to limit leverage)
    }
  }
  return_portfolio = risk_free + weight_risky*actual
  avg_utility = mean(return_portfolio[, 1])-0.5 * gamma_MV * (sd(return_portfolio[, 1]))^2;
#quadratic form where higher variance decreases utility
  return(list(avg_utility, weight_risky))
}a),1]=(nlag+1-a)/(nlag+1)
    za=hhat[,(a+1):nobs]%*%matrix(hhat[,1:(nobs-a)], ncol = nrow(hhat));
    if (a==0){
      ga=ga+za;
    }else{
    ga=ga+za+t(za);
    }
#computte the weighted sum of autocovariances
    G=G+w[(nlag+1+a),1]*ga;
    a=a+1;
  }#     end; % end of while
  
  V=xpxi*G*xpxi
#covariance matrix of regressors
  nwerr= sqrt(diag(V));
#nwerr computes robust standard errors from the diagonal of V
  results$tstat = results$beta/nwerr
#Newey-West t-statistics
  ym = y - matrix(1, nrow = nobs, ncol = 1)*mean(y);
  rsqr1 = sigu;
  rsqr2 = t(ym)%*%ym;
  results$rsqr = 1.0 - rsqr1/rsqr2# r-squared
  rsqr1 = rsqr1/(nobs-nvar);
  rsqr2 = rsqr2/(nobs-1.0);
#rsqr provide the r-squared
  